#include <amxmod>
#include <xtrafun>
#include <superheromod>
#include <vexd_utilities>

#define TE_BEAMPOINTS 0
#define TE_EXPLOSION 3
#define TE_EXPLOSION2 12

// Black Archer - Flaming Bullets and Freezing Bullets

// CVARS
// Arch_bullets - How many flaming bullets does he get each round
// Arch_getscout - Does he get a free scout on respawn.
// Arch_health - How much hp he has
// Arch_armor - How much ap he has
// Arch_gravity - How much gravity he has
// Arch_speed - How fast he is


// VARIABLES
new gHeroName[]="Black Archer"
new gHasArchPower[SH_MAXSLOTS+1]
new scoutsFired[33] = 0
new bool:cstrike_running
// Test
new gLastWeapon[33]=0
new gLastClipCount[33]=0
new lastammo[33]
new lastweap[33]
new bomb[33]
new fireice[33]
new bombcounter[33]
new firecounter[33]
new icecounter[33]
new portcounter[33]
new sleepcounter[33]

// sprites!
new spr_laser
new spr_laser_impact
new gIsBurning[SH_MAXSLOTS+1]
new gSpriteSmoke, gSpriteBurning
new bombcount[33]
new g_lastPosition[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new lPositionXUp[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new lPositionXDown[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new lPositionYUp[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new lPositionYDown[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new lPositionZDown[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new lPositionXYUpUp[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new lPositionXYDownUp[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new lPositionXYUpDown[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new lPositionXYDownDown[SH_MAXSLOTS+1][3];   // Variable to help with position checking
new xModeUp,xModeDown,yModeUp,yModeDown,zModeDown,xyUpUp,xyUpDown,xyDownUp,xyDownDown=0
new origX,origY,origZ=0
new blinkSpot[33][3]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Arch","1.2","ReVeNgIsT")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	if ( isDebugOn() ) server_print("Attempting to create Arch Hero")
	if ( !cvar_exists("Arch_level") ) register_cvar("Arch_level", "18")
	shCreateHero(gHeroName, "SpellBook", "Bow and Arrow with spell menu", true, "Arch_level" )

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// INIT
	register_srvcmd("Arch_init", "Arch_init")
	shRegHeroInit(gHeroName, "Arch_init")
	register_event("ResetHUD","newRound","b")
	register_event("CurWeapon","changeWeapon","be","1=1")
	register_event("CurWeapon","make_tracer", "be", "1=1", "3>0")
	register_event("CurWeapon","check_scout","be","1=1")
	register_event("WeapPickup","model","b","1=19")
	register_menucmd(register_menuid("Spells"),1023,"DispTelMenu")
	register_srvcmd("Arch_kd", "Arch_kd")
	shRegKeyDown(gHeroName, "Arch_kd")
	new modName[32]
	get_modname(modName,31)
	cstrike_running = equal(modName,"cstrike") ? true : false

	// DEFAULT THE CVARS
	if ( !cvar_exists("Arch_getscout") ) register_cvar("Arch_getscout", "1")
	register_cvar("Arch_numburns", "5" )
	register_cvar("Arch_burndamage", "10" )
	register_cvar("Arch_bombdmg", "70" )
	register_cvar("Arch_bombtime", "1.5" )
	register_cvar("Arch_radius", "100" )
	register_cvar("Arch_sleep", "5" )
	register_cvar("Arch_firearrows", "5" )
	register_cvar("Arch_icearrows", "5" )
	register_cvar("Arch_bombarrows", "10" )
	register_cvar("Arch_portarrows", "8" )
	register_cvar("Arch_sleeparrows", "3" )
	register_cvar("Arch_icetime", "2" )

}
//----------------------------------------------------------------------------------------------
public Arch_init()
{
	new temp[128]
	// First Argument is an id
	read_argv(1,temp,5)
	new id=str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has Arch
	read_argv(2,temp,5)
	new hasPowers=str_to_num(temp)
	gHasArchPower[id]=(hasPowers!=0)
}
//----------------------------------------------------------------------------------------------
public plugin_precache() {
	spr_laser = precache_model("sprites/laserbeam.spr")
	spr_laser_impact = precache_model("sprites/zerogxplode.spr")
	gSpriteSmoke   = precache_model("sprites/steam1.spr")
	gSpriteBurning = precache_model("sprites/xfire.spr")
	precache_sound("ambience/burning1.wav")
	precache_sound("ambience/flameburst1.wav")
	precache_sound("scientist/c1a0_sci_catscream.wav")
	precache_sound("vox/_period.wav")
	precache_model("models/arch/v_scout.mdl")
	precache_model("models/arch/bomb.mdl")
	precache_sound("weapons/xbow_hitbod2.wav")

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public Arch_give(id)
{
	if ( !is_user_alive(id) ) return
	shGiveWeapon(id,"weapon_scout")
	shGiveWeapon(id,"ammo_762nato")

	return

}
//----------------------------------------------------------------------------------------------
public newRound(id)
{
	new parm[1]
	parm[0]=id
	scoutsFired[id] = 0
	gPlayerUltimateUsed[id]=false
	gLastWeapon[id]=-1
	new args[1]
	args[0]=id
	gIsBurning[id]=0
	stopFireSound(args)

	if (gHasArchPower[id] && get_cvar_num("Arch_getscout")==1) {
		shGiveWeapon(id,"weapon_scout")

		bombcounter[id] = get_cvar_num("Arch_bombarrows")
		firecounter[id] = get_cvar_num("Arch_firearrows")
		icecounter[id] = get_cvar_num("Arch_icearrows")
		portcounter[id] = get_cvar_num("Arch_portarrows")
		sleepcounter[id] = get_cvar_num("Arch_sleeparrows")
	}
}
//----------------------------------------------------------------------------------------------
public make_tracer(id) {

	if (!shModActive()) return PLUGIN_CONTINUE
	new weap = read_data(2)        // id of the weapon
	new ammo = read_data(3)        // ammo left in clip

	if ( gHasArchPower[id] && weap == CSW_SCOUT && is_user_alive(id) && (!gPlayerUltimateUsed[id]) ) {

		if (lastweap[id] == 0) lastweap[id] = weap

		if ((lastammo[id] > ammo) && (lastweap[id] == weap)) {
			new vec1[3], vec2[3]
			get_user_origin(id, vec1, 1) // origin; where you are
			get_user_origin(id, vec2, 4) // termina; where your bullet goes

			if(fireice[id] == 3) {
				if(bombcounter[id] > 0) {
					bomb_plant(id)
				}
			}
			if(fireice[id] == 4) {
				if(portcounter[id] > 0) {
					bArch_teleport(id)
				}
			}
			// tracer beam
			message_begin(MSG_PAS, SVC_TEMPENTITY, vec1)
			write_byte(0)        // TE_BEAMPOINTS
			write_coord(vec1[0])
			write_coord(vec1[1])
			write_coord(vec1[2])
			write_coord(vec2[0])
			write_coord(vec2[1])
			write_coord(vec2[2])
			write_short(spr_laser)    // laserbeam sprite
			write_byte(0)        // starting frame
			write_byte(10)        // frame rate
			write_byte(10)        // life in 0.1s
			write_byte(4)        // line width in 0.1u
			write_byte(1)        // noise in 0.1u
			if(fireice[id] == 2) {
				write_byte(255)        // red
				write_byte(0)      // green
				write_byte(0)        // blue
			}
			if(fireice[id] == 1) {
				write_byte(0)        // red
				write_byte(0)      // green
				write_byte(255)        // blue
			}
			if(fireice[id] == 3) {
				write_byte(235)        // red
				write_byte(235)      // green
				write_byte(0)        // blue
			}
			if(fireice[id] == 4) {
				write_byte(0)        // red
				write_byte(255)      // green
				write_byte(0)        // blue
			}
			if(fireice[id] == 5) {
				write_byte(204)        // red
				write_byte(51)      // green
				write_byte(255)        // blue
			}
			if(fireice[id] == 6) {
				write_byte(255)        // red
				write_byte(255)      // green
				write_byte(255)        // blue
			}
			if(fireice[id] == 0) {
				write_byte(255)        // red
				write_byte(255)      // green
				write_byte(255)        // blue
			}
			write_byte(255)        // brightness
			write_byte(100)        // scroll speed
			message_end()

			if(fireice[id] == 5) {
				sleepcounter[id] = sleepcounter[id] - 1
				if(sleepcounter[id] > -1) {
					client_print(id,print_chat,"%i sleeping arrows left", sleepcounter[id])
				}
			}
			if(fireice[id] == 4) {
				portcounter[id] = portcounter[id] - 1
				if(portcounter[id] > -1) {
					client_print(id,print_chat,"%i portal arrows left", portcounter[id])
				}
			}
			if(fireice[id] == 3) {
				bombcounter[id] = bombcounter[id] - 1
				if(bombcounter[id] > -1) {
					client_print(id,print_chat,"%i bombs left", bombcounter[id])
				}
			}
			if(fireice[id] == 1) {
				icecounter[id] = icecounter[id] - 1
				if(icecounter[id] > -1) {
					client_print(id,print_chat,"%i ice arrows left", icecounter[id])
				}
			}
			if(fireice[id] == 2) {
				firecounter[id] = firecounter[id] - 1
				if(firecounter[id] > -1) {
					client_print(id,print_chat,"%i fire arrows left", firecounter[id])
				}
			}
			new tid,tbody
			new FFOn= get_cvar_num("mp_friendlyfire")
			get_user_aiming(id,tid,tbody,9999)
			if( tid > 0 && tid < 33 && ( FFOn || get_user_team(id)!=get_user_team(tid) ) )
			{
				if(fireice[id] == 2) {
					if(firecounter[id] > 0) {
						burn_victim(tid,id)
					}
				}
				if(fireice[id] == 1) {
					if(icecounter[id] > 0) {
						new origin[3]
						get_user_origin(tid, origin)
						origin[2] -= 25
						set_user_origin(tid, origin)
						shGlow(tid,0,0,255)
						shGlow(tid,0,255,0)
						shGlow(tid,255,0,0)
						shGlow(tid,0,235,235)
						shGlow(tid,150,20,100)
						shGlow(tid,150,225,0)
						shGlow(tid,56,100,255)
						new ids[1]
						ids[0] = tid
						set_task( get_cvar_float("Arch_icetime") ,"ice_awa", 158+tid, ids, 1)
					}
				}
				if(fireice[id] == 5) {
					if(sleepcounter[id] > 0) {
						sleep_spell(tid)
					}
				}
			}
		}

		lastammo[id] = ammo
		lastweap[id] = weap

		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------
public changeWeapon(id)
{
	if ( !gHasArchPower[id] || !shModActive() ) return PLUGIN_CONTINUE
	new  clip, ammo
	new wpn_id=get_user_weapon(id, clip, ammo);

	if ( wpn_id!=CSW_SCOUT ) return PLUGIN_CONTINUE

	// This event gets trigger on a switch to a weapon too...
	// Easy work around
	if ( wpn_id != gLastWeapon[id] )
	{
		gLastWeapon[id]=wpn_id
		return PLUGIN_CONTINUE // user just switched weapons
	}

	if ( clip >= gLastClipCount[id] )
	{
		gLastClipCount[id]=clip
		return PLUGIN_CONTINUE
	}
	gLastClipCount[id]=clip

	// Ok - if it fell through here - you got a user firing the scout

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public burn_victim(id,killer)
{
	if( Entvars_Get_Int( id, EV_INT_waterlevel ) == 3 ) return PLUGIN_CONTINUE
	if(gIsBurning[id] == 1)
	return PLUGIN_CONTINUE
	gIsBurning[id] = 1

	emit_sound(id, CHAN_ITEM, "ambience/burning1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	new args[3]
	// new hp = get_user_health(id)
	args[0] = id
	args[1] = killer
	set_task(0.3,"on_fire",451,args,3,"a", get_cvar_num("htorch_numburns") )
	set_task(0.7,"fire_scream",0,args,3)
	set_task(5.5,"stopFireSound",0,args,3)
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public on_fire(args[])
{
	if( Entvars_Get_Int( args[0], EV_INT_waterlevel ) == 3 ) return PLUGIN_CONTINUE
	new hp,rx,ry,rz,forigin[3]
	new id = args[0]
	new killer = args[1]
	rx = random_num(-30,30)
	ry = random_num(-30,30)
	rz = random_num(-30,30)
	get_user_origin(id,forigin)

	//TE_SPRITE - additive sprite, plays 1 cycle
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( 17 )
	write_coord(forigin[0]+rx) // coord, coord, coord (position)
	write_coord(forigin[1]+ry)
	write_coord(forigin[2]+10+rz)
	write_short( gSpriteBurning ) // short (sprite index)
	write_byte( 30 ) // byte (scale in 0.1's)
	write_byte( 200 ) // byte (brightness)
	message_end()

	//Smoke
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( 5 )
	write_coord(forigin[0]+(rx*2)) // coord, coord, coord (position)
	write_coord(forigin[1]+(ry*2))
	write_coord(forigin[2]+100+(rz*2))
	write_short( gSpriteSmoke )// short (sprite index)
	write_byte( 60 ) // byte (scale in 0.1's)
	write_byte( 15 ) // byte (framerate)
	message_end()

	if(is_user_alive(id) == 0)
	return PLUGIN_CONTINUE

	hp = get_user_health(id)
	new bdamage=get_cvar_num("htorch_burndamage")

	set_user_health(id,hp - bdamage )
	if(hp - bdamage < 1)
	{
		new namek[32],namev[32],authida[40],authidv[40],teama[32],teamv[32]
		get_user_name(id,namev,31)
		get_user_name(killer,namek,31)
		get_user_authid(id,authidv,39)
		get_user_authid(killer,authida,39)
		get_user_team(id,teamv,31)
		get_user_team(killer,teama,31)

		message_begin( MSG_BROADCAST, get_user_msgid("DeathMsg"),{0,0,0},0)
		write_byte(killer)
		write_byte(id)
		write_byte(0)
		write_string("Flame Thrower")
		message_end()

		if (equali(teama, teamv))
		shAddXP(killer, id, 1)
		else
		shAddXP(killer, id, -1)

		//Log This Kill
		logKill(killer,id,"Flaming Arrow")

		new fr = get_user_frags(killer)
		set_user_frags(killer,fr + 1)
		new fr2 = get_user_frags(id)
		set_user_frags(id,fr2 + 1)
	}
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public fire_scream(args[])
{
	emit_sound(args[0], CHAN_AUTO, "scientist/c1a0_sci_catscream.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public stopFireSound(args[])
{
	new sndStop=(1<<5)
	gIsBurning[args[0]] = 0
	emit_sound(args[0], CHAN_ITEM, "ambience/burning1.wav", 1.0, ATTN_NORM, sndStop, PITCH_NORM)
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public model(id) {
	if ( !is_user_alive(id) || !gHasArchPower[id] ) return

	new clip, ammo, wpn_id = get_user_weapon(id,clip,ammo)
	if ( wpn_id == CSW_SCOUT ){
		// Weapon Model change thanks to [CCC]Taz-Devil
		Entvars_Set_String(id, EV_SZ_viewmodel, "models/arch/v_scout.mdl")
	}
}
//----------------------------------------------------------------------------------------------
public check_scout(id)
{
	if ( !gHasArchPower[id] || !shModActive() ) return PLUGIN_CONTINUE
	new clip, ammo
	new wpn_id=get_user_weapon(id, clip, ammo)

	if ( wpn_id == CSW_SCOUT ) model(id)

	if ( !gHasArchPower[id] || !shModActive() ) return PLUGIN_CONTINUE

	new wpn[32]
	if ( wpn_id!=CSW_SCOUT ) return PLUGIN_CONTINUE

	// Never Run Out of Ammo!
	//server_print("STATUS ID=%d CLIP=%d, AMMO=%d WPN=%d", id, clip, ammo, wpn_id)
	if ( clip == 0 )
	{
		//server_print("INVOKING MATTBT MODE! ID=%d CLIP=%d, AMMO=%d WPN=%d", id, clip, ammo, wpn_id)
		get_weaponname(wpn_id,wpn,31)
		//highly recommend droppging weapon - buggy without it!
		give_item(id,wpn)
		engclient_cmd(id, wpn )
		engclient_cmd(id, wpn ) // Checking to see if multple sends helps - sometimes this doesn't work... ;-(
		engclient_cmd(id, wpn ) // Checking to see if multple sends helps - sometimes this doesn't work... ;-(
	}
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public Arch_kd()
{
	new temp[6]

	// First Argument is an id with agent Powers!
	read_argv(1,temp,5)
	new id=str_to_num(temp)
	showMenu(id)
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public DispTelMenu(id,key)
{
	switch(key){

		case 0:{
			fireice[id] = 2
			new message[128]
			format(message, 127, "Fire spell cast on arrows" )
			set_hudmessage(255,0,0,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
			show_hudmessage(id, message)
		}
		case 1:{
			fireice[id] = 1
			new message[128]
			format(message, 127, "Ice spell cast on arrows" )
			set_hudmessage(0,0,255,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
			show_hudmessage(id, message)
		}
		case 2:{
			fireice[id] = 3
			new message[128]
			format(message, 127, "Bomb spell cast on arrows" )
			set_hudmessage(255,255,51,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
			show_hudmessage(id, message)
		}
		case 3:{
			fireice[id] = 4
			new message[128]
			format(message, 127, "Portal spell cast on arrows" )
			set_hudmessage(255,255,51,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
			show_hudmessage(id, message)
		}
		case 4:{
			fireice[id] = 5
			new message[128]
			format(message, 127, "Sleep spell cast on arrows" )
			set_hudmessage(255,255,51,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
			show_hudmessage(id, message)
		}
		case 5:{
			fireice[id] = 6
			new message[128]
			format(message, 127, "Regular arrows loaded in bow" )
			set_hudmessage(1000,1000,1000,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
			show_hudmessage(id, message)
		}
	}
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public showMenu(id)
{

	new menuBody[512]
	new len = format(menuBody,511,cstrike_running ? "\ySpells\R^n^n\w" : "Spells^n^n")
	len += format(menuBody[len],511-len,"1. Cast Fire^n2. Cast Ice^n3. Cast Bomb^n4. Cast Portal^n5. Cast Sleep^n6. Regular Arrows^n^n0. Exit")
	show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<9)),menuBody)

	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public bomb_plant(id)
{
	if(bombcount[id]== 0) {
		new Float:PlayerOrigin[3]
		new orig[3]
		get_user_origin(id, orig, 4)
		PlayerOrigin[0] = float(orig[0])
		PlayerOrigin[1] = float(orig[1])
		PlayerOrigin[2] = float(orig[2])

		bomb[id] = CreateEntity("info_target")

		if(bomb[id] == 0) return

		Entvars_Set_String(bomb[id], EV_SZ_classname, "Arch_bomb")

		ENT_SetModel(bomb[id], "models/arch/bomb.mdl")

		new Float:MinBox[3]
		new Float:MaxBox[3]
		MinBox[0] = -1.0
		MinBox[1] = -1.0
		MinBox[2] = -1.0
		MaxBox[0] = 1.0
		MaxBox[1] = 1.0
		MaxBox[2] = 1.0

		Entvars_Set_Vector(bomb[id], EV_VEC_mins, MinBox)
		Entvars_Set_Vector(bomb[id], EV_VEC_maxs, MaxBox)

		new Float:Angles[3]
		Entvars_Get_Vector(id, EV_VEC_v_angle, Angles)

		ENT_SetOrigin(bomb[id], PlayerOrigin)
		Entvars_Set_Vector(bomb[id], EV_VEC_angles, Angles)
		Entvars_Set_Int(bomb[id], EV_INT_solid, 2)
		Entvars_Set_Int(bomb[id], EV_INT_movetype, 4)
		Entvars_Set_Edict(bomb[id], EV_ENT_owner, id)
		new ids[1]
		ids[0] = id
		set_task( get_cvar_float("Arch_bombtime") ,"bomb_time", 123+id, ids, 1)
		bombcount[id] = 1
	}
}
//------------------------------------------------------------------------------------------------
public bomb_time(ids[])
{
	remove_task(123+ids[0])
	tExplode(ids[0])

	return PLUGIN_HANDLED
}
//------------------------------------------------------------------------------------------------
public tExplode(id)
{
	new Float: bombExplodeAt[33][3]

	Entvars_Get_Vector(bomb[id], EV_VEC_origin, bombExplodeAt[id])
	new origin1[3]
	origin1[0] = floatround(bombExplodeAt[id][0])
	origin1[1] = floatround(bombExplodeAt[id][1])
	origin1[2] = floatround(bombExplodeAt[id][2])
	new origin2[3]
	new inum, players[32]
	new FFOn= get_cvar_num("mp_friendlyfire")
	if (FFOn==0) {
		new team[33]
		get_user_team(id,team,32)
		if (equali(team,"CT")) {
			get_players(players,inum,"ae","TERRORIST")
		}
		else {
			get_players(players,inum,"ae","CT")
		}
	}
	else {
		get_players(players,inum) //get number of players
	}
	for (new i=0; i<inum; ++i){
		get_user_origin(players[i], origin2)
		new distance = get_distance( origin1, origin2)
		if ( (distance < get_cvar_num("Arch_radius")) ) {

			message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
			write_byte(TE_BEAMPOINTS)
			write_coord(origin1[0])
			write_coord(origin1[1])
			write_coord(origin1[2])
			write_coord(origin2[0])
			write_coord(origin2[1])
			write_coord(origin2[2])
			write_short(spr_laser)   // model
			write_byte(1) // start frame
			write_byte(20) // framerate
			write_byte(6) // life
			write_byte(300)  // width
			write_byte(2)   // noise
			write_byte(235)   // r, g, b
			write_byte(235)   // r, g, b
			write_byte(0)   // r, g, b
			write_byte(500)   // brightness
			write_byte(2)      // speed
			message_end()


			message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
			write_byte(TE_EXPLOSION)
			write_coord(origin2[0])
			write_coord(origin2[1])
			write_coord(origin2[2])
			write_short(spr_laser_impact)
			write_byte(100)
			write_byte(50)
			write_byte(0)
			message_end()

			message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
			write_byte(TE_EXPLOSION)
			write_coord(origin2[0]+20)
			write_coord(origin2[1]+20)
			write_coord(origin2[2])
			write_short(spr_laser_impact)
			write_byte(100)
			write_byte(100)
			write_byte(0)
			message_end()

			message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
			write_byte(TE_EXPLOSION)
			write_coord(origin2[0]-20)
			write_coord(origin2[1]-20)
			write_coord(origin2[2])
			write_short(spr_laser_impact)
			write_byte(100)
			write_byte(150)
			write_byte(0)
			message_end()

			message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
			write_byte(TE_EXPLOSION2)
			write_coord(origin2[0])
			write_coord(origin2[1])
			write_coord(origin2[2])
			write_byte(188) // start color
			write_byte(10) // num colors
			message_end()

			shExtraDamage(players[i], id, get_cvar_num("Arch_bombdmg"), "Arch's Bomb")
		}
	}
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte(TE_EXPLOSION)
	write_coord(origin1[0])
	write_coord(origin1[1])
	write_coord(origin1[2])
	write_short(spr_laser_impact)
	write_byte(100)
	write_byte(50)
	write_byte(0)
	message_end()
	RemoveEntity(bomb[id])
	bombcount[id] = 0

	return PLUGIN_HANDLED
}
//------------------------------------------------------------------------------------------
public sleep_spell(id)
{
	new origin[3]
	get_user_origin(id,origin)
	origin[2] -= 2000
	set_user_origin(id,origin)
	new ids[1]
	ids[0] = id
	new message[128]
	format(message, 127, "You have been put in a sleepspell")
	set_hudmessage(255,255,51,-1.0,-1.0,0,0.25,1.0,0.0,0.0,4)
	show_hudmessage(id, message)
	client_print(id,print_chat,"You are feeling sleeeepy")
	client_print(id,print_chat,"***You will awake soon though***")
	set_task( get_cvar_float("Arch_sleep") ,"sleep_awa", 143+id, ids, 1)
}
//--------------------------------------------------------------------------------------------
public sleep_awa(ids[])
{
	sleep_awake(ids[0])
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------
public sleep_awake(id)
{
	new message[128]
	format(message, 127, "You have awaken from the sleep spell" )
	set_hudmessage(255,255,51,-1.0,-1.0,0,0.25,1.0,0.0,0.0,4)
	show_hudmessage(id, message)
	new originb[3]
	get_user_origin(id,originb)
	originb[2] += 2000
	set_user_origin(id,originb)
}
//----------------------------------------------------------------------------------------------
public ice_awa(ids[])
{
	ice_awake(ids[0])
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------
public ice_awake(id)
{
	new originb[3]
	get_user_origin(id,originb)
	originb[2] += 25
	set_user_origin(id,originb)
}
//----------------------------------------------------------------------------------------------
public bArch_teleport(id)
{
	xModeUp=0
	xModeDown=0
	yModeUp=0
	yModeDown=0
	zModeDown=0
	xyUpUp=0
	xyUpDown=0
	xyDownUp=0
	xyDownDown=0
	get_user_origin(id,blinkSpot[id],3)
	blinkSpot[id][2]=(blinkSpot[id][2]+45)
	set_user_origin(id,blinkSpot[id])
	/*  new debug[128]
	format(debug, 127, "You are at x: %i y: %i z: %i", blinkSpot[id][0], blinkSpot[id][1], blinkSpot[id][2] )
	set_hudmessage(255,0,0,-1.0,0.3,0,1.0,1.0,0.0,0.0,4)
	show_hudmessage( id, debug)
	console_print(id,"Your coords are x: %i y: %i z: %i", blinkSpot[id][0],blinkSpot[id][1],blinkSpot[id][2]) */  // debugging purposes
	positionChangeTimer(id, 0.1 )
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public positionChangeTimer(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	g_lastPosition[id][0]=origin[0]
	g_lastPosition[id][1]=origin[1]
	g_lastPosition[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"positionChangeCheck",0,parm,1)
}
//----------------------------------------------------------------------------------------------
public positionChangeCheck( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)

	if ( g_lastPosition[id][0] == origin[0] && g_lastPosition[id][1] == origin[1] && g_lastPosition[id][2] == origin[2] && is_user_alive(id) )
	{
		//    console_print(id,"You have been checked at - x: %i y: %i z: %i",blinkSpot[id][0],blinkSpot[id][1],blinkSpot[id][2])  //debugging purposes
		if (zModeDown!=1) {
			bArch_down(id)
		}
	}
}
//----------------------------------------------------------------------------------------------
public bArch_forward(id)
{
	origY=blinkSpot[id][1]
	blinkSpot[id][1]=(blinkSpot[id][1]+20)
	//  console_print(id,"Forward: %i",blinkSpot[id][1])  // debugging purposes
	set_user_origin(id,blinkSpot[id])
	pTimeForward(id, 0.1)
}
//----------------------------------------------------------------------------------------------
public bArch_forwardleft(id)
{
	origX=blinkSpot[id][0]
	origY=blinkSpot[id][1]
	blinkSpot[id][0]=(blinkSpot[id][0]-24)
	blinkSpot[id][1]=(blinkSpot[id][1]+24)
	//  console_print(id,"Forward: %i  Left: %i",blinkSpot[id][1],blinkSpot[id][0])  // debugging purposes
	set_user_origin(id,blinkSpot[id])
	pTimeForwardLeft(id, 0.1)
}
//----------------------------------------------------------------------------------------------
public bArch_forwardright(id)
{
	origX=blinkSpot[id][0]
	origY=blinkSpot[id][1]
	blinkSpot[id][0]=(blinkSpot[id][0]+24)
	blinkSpot[id][1]=(blinkSpot[id][1]+24)
	//  console_print(id,"Forward: %i  Right: %i",blinkSpot[id][1],blinkSpot[id][0])  // debugging purposes
	set_user_origin(id,blinkSpot[id])
	pTimeForwardRight(id, 0.1)
}
//----------------------------------------------------------------------------------------------
public bArch_back(id)
{
	origY=blinkSpot[id][1]
	blinkSpot[id][1]=(blinkSpot[id][1]-20)
	//  console_print(id,"Backward: %i",blinkSpot[id][1])  // debugging purposes
	set_user_origin(id,blinkSpot[id])
	pTimeBackward(id, 0.1)
}
//----------------------------------------------------------------------------------------------
public bArch_backleft(id)
{
	origX=blinkSpot[id][0]
	origY=blinkSpot[id][1]
	blinkSpot[id][0]=(blinkSpot[id][0]-24)
	blinkSpot[id][1]=(blinkSpot[id][1]-24)
	//  console_print(id,"Backward: %i  Left: %i",blinkSpot[id][1],blinkSpot[id][0])  // debugging purposes
	set_user_origin(id,blinkSpot[id])
	pTimeBackwardLeft(id, 0.1)
}
//----------------------------------------------------------------------------------------------
public bArch_backright(id)
{
	origX=blinkSpot[id][0]
	origY=blinkSpot[id][1]
	blinkSpot[id][0]=(blinkSpot[id][0]+24)
	blinkSpot[id][1]=(blinkSpot[id][1]-24)
	//  console_print(id,"Backward: %i  Right: %i",blinkSpot[id][1],blinkSpot[id][0])  // debugging purposes
	set_user_origin(id,blinkSpot[id])
	pTimeBackwardRight(id, 0.1)
}
//----------------------------------------------------------------------------------------------
public bArch_left(id)
{
	origX=blinkSpot[id][0]
	blinkSpot[id][0]=(blinkSpot[id][0]-20)
	//  console_print(id,"Left: %i",blinkSpot[id][0])  // debugging purposes
	set_user_origin(id,blinkSpot[id])
	pTimeLeft(id, 0.1)
}
//----------------------------------------------------------------------------------------------
public bArch_right(id)
{
	origX=blinkSpot[id][0]
	blinkSpot[id][0]=(blinkSpot[id][0]+20)
	//  console_print(id,"Right: %i",blinkSpot[id][0])  // debugging purposes
	set_user_origin(id,blinkSpot[id])
	pTimeRight(id, 0.1)
}
//----------------------------------------------------------------------------------------------
public bArch_down(id)
{
	origZ=blinkSpot[id][2]
	blinkSpot[id][2]=(blinkSpot[id][2]-60)
	//  console_print(id,"Down: %i",blinkSpot[id][2])  // debugging purposes
	set_user_origin(id,blinkSpot[id])
	pTimeDown(id, 0.1)
}
//----------------------------------------------------------------------------------------------
public pTimeForward(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	lPositionYUp[id][0]=origin[0]
	lPositionYUp[id][1]=origin[1]
	lPositionYUp[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"pCheckForward",0,parm,1)
}
//----------------------------------------------------------------------------------------------
public pCheckForward( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)
	new testY=blinkSpot[id][1]

	if ( lPositionYUp[id][0] == origin[0] && lPositionYUp[id][1] == origin[1] && lPositionYUp[id][2] == origin[2] && is_user_alive(id) )
	{
		//    console_print(id,"Forward failed")  //debugging purposes
		yModeUp=0
		blinkSpot[id][1]=origY
		if (yModeUp!=1 && yModeDown!=1) {
			bArch_back(id)
		}
	}
	else {
		yModeUp=1
		//    console_print(id,"Forward successful")  //debugging purposes
		blinkSpot[id][1]=testY
		yModeDown=1
	}
	set_user_origin(id,blinkSpot[id])
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pTimeForwardLeft(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	lPositionXYDownUp[id][0]=origin[0]
	lPositionXYDownUp[id][1]=origin[1]
	lPositionXYDownUp[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"pCheckForwardLeft",0,parm,1)
}
//----------------------------------------------------------------------------------------------
public pCheckForwardLeft( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)
	new testX=blinkSpot[id][0]
	new testY=blinkSpot[id][1]

	if ( lPositionXYDownUp[id][0] == origin[0] && lPositionXYDownUp[id][1] == origin[1] && lPositionXYDownUp[id][2] == origin[2] && is_user_alive(id) )
	{
		//    console_print(id,"Forward Left failed")  //debugging purposes
		xyDownUp=0
		blinkSpot[id][0]=origX
		blinkSpot[id][1]=origY
		if (xyDownUp!=1 && xyUpUp!=1) {
			bArch_forwardright(id)
		}
	}
	else {
		xyDownUp=1
		//    console_print(id,"Forward Left successful")  //debugging purposes
		blinkSpot[id][0]=testX
		blinkSpot[id][1]=testY
		xyUpUp=1
	}
	set_user_origin(id,blinkSpot[id])
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pTimeForwardRight(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	lPositionXYUpUp[id][0]=origin[0]
	lPositionXYUpUp[id][1]=origin[1]
	lPositionXYUpUp[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"pCheckForwardRight",0,parm,1)
}
//----------------------------------------------------------------------------------------------
public pCheckForwardRight( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)
	new testX=blinkSpot[id][0]
	new testY=blinkSpot[id][1]

	if ( lPositionXYUpUp[id][0] == origin[0] && lPositionXYUpUp[id][1] == origin[1] && lPositionXYUpUp[id][2] == origin[2] && is_user_alive(id) )
	{
		//    console_print(id,"Forward Right failed")  //debugging purposes
		xyUpUp=0
		blinkSpot[id][0]=origX
		blinkSpot[id][1]=origY
		if (xyUpUp!=1 && xyDownDown!=1) {
			bArch_backleft(id)
		}
	}
	else {
		xyUpUp=1
		//    console_print(id,"Forward Right successful")  //debugging purposes
		blinkSpot[id][0]=testX
		blinkSpot[id][1]=testY
		xyDownDown=1
	}
	set_user_origin(id,blinkSpot[id])
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pTimeBackward(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	lPositionYDown[id][0]=origin[0]
	lPositionYDown[id][1]=origin[1]
	lPositionYDown[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"pCheckBackward",0,parm,1)
}
//----------------------------------------------------------------------------------------------
public pCheckBackward( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)
	new testY=blinkSpot[id][1]

	if ( lPositionYDown[id][0] == origin[0] && lPositionYDown[id][1] == origin[1] && lPositionYDown[id][2] == origin[2] && is_user_alive(id) )
	{
		//   console_print(id,"Backward failed")  // debugging purposes
		yModeDown=0
		blinkSpot[id][1]=origY
		if (yModeDown!=1 && xModeDown!=1) {
			bArch_left(id)
		}
	}
	else {
		yModeDown=1
		//    console_print(id,"Backward successful")  // debugging purposes
		blinkSpot[id][1]=testY
		yModeUp=1
	}
	set_user_origin(id,blinkSpot[id])
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pTimeBackwardLeft(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	lPositionXYDownDown[id][0]=origin[0]
	lPositionXYDownDown[id][1]=origin[1]
	lPositionXYDownDown[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"pCheckBackwardLeft",0,parm,1)
}
//----------------------------------------------------------------------------------------------
public pCheckBackwardLeft( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)
	new testX=blinkSpot[id][0]
	new testY=blinkSpot[id][1]

	if ( lPositionXYDownDown[id][0] == origin[0] && lPositionXYDownDown[id][1] == origin[1] && lPositionXYDownDown[id][2] == origin[2] && is_user_alive(id) )
	{
		//    console_print(id,"Backward Left failed")  //debugging purposes
		xyDownDown=0
		blinkSpot[id][0]=origX
		blinkSpot[id][1]=origY
		if (xyDownDown!=1 && xyUpDown!=1) {
			bArch_backright(id)
		}
	}
	else {
		xyDownDown=1
		//    console_print(id,"Backward Left successful")  //debugging purposes
		blinkSpot[id][0]=testX
		blinkSpot[id][1]=testY
		xyUpDown=1
	}
	set_user_origin(id,blinkSpot[id])
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pTimeBackwardRight(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	lPositionXYUpDown[id][0]=origin[0]
	lPositionXYUpDown[id][1]=origin[1]
	lPositionXYUpDown[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"pCheckBackwardRight",0,parm,1)
}
//----------------------------------------------------------------------------------------------
public pCheckBackwardRight( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)
	new testX=blinkSpot[id][0]
	new testY=blinkSpot[id][1]

	if ( lPositionXYUpDown[id][0] == origin[0] && lPositionXYUpDown[id][1] == origin[1] && lPositionXYUpDown[id][2] == origin[2] && is_user_alive(id) )
	{
		//    console_print(id,"Backward Right failed")  //debugging purposes
		xyUpDown=0
		blinkSpot[id][0]=origX
		blinkSpot[id][1]=origY
		killTime(id, 0.1)
		//    console_print(id,"No other places to teleport to... DAMNIT")  // debugging purposes
		return PLUGIN_HANDLED
	}
	else {
		xyUpDown=1
		//    console_print(id,"Backward Right successful")  //debugging purposes
		blinkSpot[id][0]=testX
		blinkSpot[id][1]=testY
		xyUpUp=1
	}
	set_user_origin(id,blinkSpot[id])
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pTimeLeft(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	lPositionXDown[id][0]=origin[0]
	lPositionXDown[id][1]=origin[1]
	lPositionXDown[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"pCheckLeft",0,parm,1)
}
//----------------------------------------------------------------------------------------------
public pCheckLeft( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)
	new testX=blinkSpot[id][0]

	if ( lPositionXDown[id][0] == origin[0] && lPositionXDown[id][1] == origin[1] && lPositionXDown[id][2] == origin[2] && is_user_alive(id) )
	{
		//    console_print(id,"Left failed")  // debugging purposes
		xModeDown=0
		blinkSpot[id][0]=origX
		if (xModeDown!=1 && xModeUp!=1) {
			bArch_right(id)
		}
	}
	else {
		xModeDown=1
		//    console_print(id,"Left successful")  // debugging purposes
		blinkSpot[id][0]=testX
		xModeUp=1
	}
	set_user_origin(id,blinkSpot[id])
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pTimeRight(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	lPositionXUp[id][0]=origin[0]
	lPositionXUp[id][1]=origin[1]
	lPositionXUp[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"pCheckRight",0,parm,1)
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pCheckRight( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)
	new testX=blinkSpot[id][0]

	if ( lPositionXUp[id][0] == origin[0] && lPositionXUp[id][1] == origin[1] && lPositionXUp[id][2] == origin[2] && is_user_alive(id) )
	{
		//    console_print(id,"Right failed")  // debugging purposes
		xModeUp=0
		blinkSpot[id][0]=origX
		if (xModeUp!=1 && xyDownUp!=1) {
			bArch_forwardleft(id)
		}
	}
	else {
		xModeUp=1
		//    console_print(id,"Right successful")  // debugging purposes
		blinkSpot[id][0]=testX
		xModeDown=1
	}
	set_user_origin(id,blinkSpot[id])
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pTimeDown(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	lPositionZDown[id][0]=origin[0]
	lPositionZDown[id][1]=origin[1]
	lPositionZDown[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"pCheckDown",0,parm,1)
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public pCheckDown( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)
	new testZ=blinkSpot[id][2]

	if ( lPositionZDown[id][0] == origin[0] && lPositionZDown[id][1] == origin[1] && lPositionZDown[id][2] == origin[2] && is_user_alive(id) )
	{
		//    console_print(id,"Down failed")  // debugging purposes
		zModeDown=0
		blinkSpot[id][2]=origZ
		if (zModeDown!=1 && yModeUp!=1) {
			bArch_forward(id)
		}
		return PLUGIN_HANDLED
	}
	else {
		zModeDown=1
		//    console_print(id,"Down successful")  // debugging purposes
		blinkSpot[id][2]=testZ
	}
	set_user_origin(id,blinkSpot[id])
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public killTime(id, Float: secs)
{
	new origin[3]
	new velocity[3]

	get_user_origin(id, origin, 0)
	g_lastPosition[id][0]=origin[0]
	g_lastPosition[id][1]=origin[1]
	g_lastPosition[id][2]=origin[2]

	get_user_velocity(id, velocity)
	if ( velocity[0]==0 && velocity[1]==0 && velocity[2] )
	{
		velocity[0]=50
		velocity[1]=50
		set_user_velocity(id, velocity)
	}

	new parm[1]
	parm[0]=id
	set_task(secs,"killCheck",0,parm,1)
}
//----------------------------------------------------------------------------------------------
public killCheck( parm[1] )
{
	new id=parm[0]
	new origin[3]

	get_user_origin(id, origin, 0)

	if ( g_lastPosition[id][0] == origin[0] && g_lastPosition[id][1] == origin[1] && g_lastPosition[id][2] == origin[2] && is_user_alive(id) )
	{
		// Kill this player - BArch Stuck in wall!
		set_user_health(id, -1)
		set_user_frags(id, get_user_frags(id)+1)
	}
}
//----------------------------------------------------------------------------------------------